VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DI8Engine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' Direct Input variables
Private dx As DirectX8                   ' Main DX object
Private di As DirectInput8               ' Main DI object
Private diKeyboard As DirectInputDevice8 ' The device for the keyboard
Private diKeyState As DIKEYBOARDSTATE    ' The keyboard state
Public Wait As Integer                   ' How long to wait for next input
Private Counter As Integer               ' How long have we waited

' Target Hwnd
Public aHwnd As Long

' Returns true if a key is pressed
Public Function GetKeyState(lKey As Long) As Boolean
    GetKeyState = (diKeyState.Key(lKey) <> 0)
End Function

' Initializes the input devices. Returns true if sucessful
Public Function InitializeDI(Optional HaveMouse As Boolean = False) As Boolean

    On Error GoTo ErrorHandler
    
    Set dx = New DirectX8
    
    ' Create a DirectInput object
    Set di = dx.DirectInputCreate()
    
    ' Set the keyboard GUID
    Set diKeyboard = di.CreateDevice("GUID_SysKeyboard")
    
    ' Set the format of the keyboard state
    diKeyboard.SetCommonDataFormat DIFORMAT_KEYBOARD
    
    ' Set the cooperative level and start the device
    diKeyboard.SetCooperativeLevel aHwnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    diKeyboard.Acquire

    InitializeDI = True
    
    Exit Function

ErrorHandler:
    
    InitializeDI = False
End Function

' Function updates all keystates
Public Function CheckAllKeys() As Boolean
On Error GoTo ErrorHandler

    ' If we don't have to wait anymore get key states
    If Counter >= Wait Then
        diKeyboard.GetDeviceStateKeyboard diKeyState
        Counter = 0
        Wait = 0
        CheckAllKeys = True
    Else ' Wait
        Counter = Counter + 1
        CheckAllKeys = False
    End If
        
    
ErrorHandler:
End Function

' Ends the directInput objects
Public Sub TerminateDI()
    
    ' Unload the keyboard
    diKeyboard.Unacquire
    
    Set diKeyboard = Nothing
    Set di = Nothing
    Set dx = Nothing
    
End Sub
