VERSION 5.00
Begin VB.Form frmView 
   Caption         =   "Form1"
   ClientHeight    =   7950
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   10470
   LinkTopic       =   "Form1"
   ScaleHeight     =   530
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   698
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   7200
      Left            =   120
      ScaleHeight     =   476
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   636
      TabIndex        =   0
      Top             =   120
      Width           =   9600
   End
   Begin VB.Label Label1 
      Caption         =   $"frmView.frx":0000
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   7560
      Width           =   10215
   End
End
Attribute VB_Name = "frmView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim Engine As New D3D8Engine
Dim DiEngine As New DI8Engine
Dim bRunning As Boolean
Dim WeatherOn As Boolean
Dim tmpChar As New Character

Public Sub SinglePlayer()

    Me.Show         ' make sure the form is shown
    
    oMap.sFilename = CommonPath & "\world.map"
    oMap.LoadMap

    If IsFullscreen Then
        Engine.aHwnd = Me.hWnd
    Else
        Engine.aHwnd = Picture1.hWnd
        Picture1.Height = RESY
        Picture1.Width = RESX
    End If

    Engine.InitD3D Not IsFullscreen
    
    DiEngine.aHwnd = Me.hWnd
    
    DiEngine.InitializeDI
    
    If Not Engine.LoadSurface(oMap.SurfaceName, CommonPath & "\" & oMap.SurfaceName) Then
        MsgBox "Error loading TileSet"
    End If
    
    If Not Engine.LoadSurface("s02char.bmp", CommonPath & "\s02char.bmp") Then
        MsgBox "Error Loading Character Sprite"
    End If
        
    If Not Engine.LoadSurface("TextBox", CommonPath & "\talkbox.bmp") Then
        MsgBox "Error Loading Character Sprite"
    End If
    
    If Not Engine.LoadSurface("Particle", CommonPath & "\particle.bmp") Then
        MsgBox "Error Loading Particle Sprite"
    End If
    
    If Not Engine.LoadSurface("MainFont", CommonPath & "\CustomFont2.bmp") Then
        MsgBox "Error Loading Custom Font"
    End If
        
    oMap.AddCharacter 0
    oMap.ActiveCharacter = 0
    
    Engine.SetUpFont
    Engine.InitParticles
    
    bRunning = True
    Dim TempTime As Long
    
    Do While bRunning

        'TempTime = timeGetTime

        If DiEngine.CheckAllKeys Then
            
            If DiEngine.GetKeyState(DIK_LCONTROL) Then
                If oMap.CheckData Then
                    DiEngine.Wait = 15
                End If
            End If
                
            If DiEngine.GetKeyState(DIK_UP) Then
                If oMap.MoveActiveCharacter(MEUP) Then DiEngine.Wait = 10
            ElseIf DiEngine.GetKeyState(DIK_DOWN) Then
                If oMap.MoveActiveCharacter(MEDOWN) Then DiEngine.Wait = 10
            ElseIf DiEngine.GetKeyState(DIK_LEFT) Then
                If oMap.MoveActiveCharacter(MELEFT) Then DiEngine.Wait = 10
            ElseIf DiEngine.GetKeyState(DIK_RIGHT) Then
                If oMap.MoveActiveCharacter(MERIGHT) Then DiEngine.Wait = 10
            End If
                
                
            If DiEngine.GetKeyState(DIK_F1) Then
                Engine.Brighten
            ElseIf DiEngine.GetKeyState(DIK_F2) Then
                Engine.Darken
            ElseIf DiEngine.GetKeyState(DIK_F3) Then
                Engine.SetFog True
            ElseIf DiEngine.GetKeyState(DIK_F4) Then
                Engine.SetFog False
            ElseIf DiEngine.GetKeyState(DIK_F5) Then
                WeatherOn = Not WeatherOn
                DiEngine.Wait = 5
            ElseIf DiEngine.GetKeyState(DIK_F6) Then
                oMap.AddFormattedBox "<FULLSCREEN><DIM 50,100><POS 50,35><SIZE 18> Dragon Claw: <POS 50,50><SIZE 14> This is a test of a custom font rasterizer.  It automatically detects the end of the screen. <POS 5,5><SETMAXWIDTH 50> The font and basics of the code is from DX4VB.  Look at this custom boundry. <SIZE 20><POS 5,50> And different font sizes."
                DiEngine.Wait = 10
            ElseIf DiEngine.GetKeyState(DIK_F7) Then
                oMap.AddInputBox "<DIM 100,50><CURSOROFFSET 2><INPUTBOX 10,15 10,20 60,15 60,20><SIZE 16><POS 10,15> Selection 1 <POS 60,15> Selection 3 <POS 10,20> Selection 2 <POS 60,20> Selection 4"
                DiEngine.Wait = 10
            End If
        
            If DiEngine.GetKeyState(DIK_F9) Then
                bRunning = False
            End If
            
        End If
        
        Set tmpChar = oMap.Character_Data(0)
        
        Engine.StartRender
        
        Engine.DrawAll oMap
        
        oMap.DoMapEvents Engine
        
        Engine.PlotText "FPS:" & Engine.FPS, 0, 0, COLOR_MAGENTA
        
        If WeatherOn Then
            Engine.RenderParticles
        End If

        Engine.EndRender
        
        DoEvents
        
        'Do Until timeGetTime >= TempTime + 16
        '    DoEvents
        'Loop
                        
    Loop
    
    Engine.TerminateD3D
    DiEngine.TerminateDI
    
    Unload Me
    End
End Sub


Private Sub Form_Unload(Cancel As Integer)
    bRunning = False
End Sub

